module.exports = {
	path: "/logout",
	/**
	 * logout user
	 * @url /api/logout
	 * @method GET
	 */
	get: (req, res) => {
		// user needs to be logged in
		if(!req.session || !req.session.user) {
			return res.type('json').end(JSON.stringify({
				status: 401,
				message: 'msg.auth.login.required'
			}));
		// logout user
		} else {
			res.clearCookie('RememberMe');
			req.session.destroy();
			return res.type('json').end(JSON.stringify({
				status: 200,
				message: 'msg.auth.logout.successful'
			}));
		}
	}
};
